Bug 476720

Summary: Review Request: beteckna-sfd-fonts - Beteckna fonts
Product: [Fedora] Fedora Reporter: Ankur Sinha <sanjay_ankur>
Component: Package ReviewAssignee: Ankur Sinha (FranciscoD) <sanjay.ankur>
Status: CLOSED NEXTRELEASE QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: low    
Version: rawhideCC: fedora-package-review, fonts-bugs, notting, sanjay.ankur, sundaram
Target Milestone: ---Flags: nicolas.mailhot: fedora‑review+
kevin: fedora‑cvs+
Target Release: ---   
Hardware: noarch   
OS: Linux   
Whiteboard:
Fixed In Version: 0.3-4.fc10 Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2009-04-17 14:04:28 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Description Ankur Sinha 2008-12-16 13:45:49 EST
Package for review..

Beteckna fonts..

http://ankursinha.fedorapeople.org/beteckna-0.3/beteckna-sfd-fonts.spec

http://ankursinha.fedorapeople.org/beteckna-0.3/beteckna-sfd-fonts-0.3-1.fc10.src.rpm

it gives a "FindMatchinHVEdge didn't" during build but builds successfully.. 

Am not yet sponsored.
Comment 1 Jason Tibbitts 2008-12-16 18:32:51 EST
We have scripts which parse these review requests, so it is much better if you follow the submission instructions at http://fedoraproject.org/wiki/PackageMaintainers/Join
Comment 2 Nicolas Mailhot 2008-12-21 16:43:59 EST
[This is a simplified version of the message sent to every package maintainer that ships TTF/OTF/Type1 fonts in Fedora.]

Our font packaging guidelines have now changed. New font package submissions must now be adapted to the new templates available in the fontpackages-devel
package:
 – http://fedoraproject.org/wiki/fontpackageshttp://fedoraproject.org/wiki/Simple_fonts_spec_templatehttp://fedoraproject.org/wiki/Fonts_spec_template_for_multiple_fonts

It is preferred to create a font package or subpackage per font family, though
it is not currently a hard guidelines requirement.
http://fedoraproject.org/wiki/PackagingDrafts/Font_package_splitting_rules_(2008-12-21)
has been submitted for FPC and FESCO approval today.

The new templates should make the creation of font packages easy and safe. 

The following packages have already been converted by their packager in fedora-devel and can serve as examples:
❄ abyssinica-fonts
❄ andika-fonts
❄ apanov-heuristica-fonts
❄ bitstream-vera-fonts
❄ charis-fonts
❄ dejavu-fonts
❄ ecolier-court-fonts
❄ edrip-fonts
❄ gfs-ambrosia-fonts
❄ gfs-artemisia-fonts
❄ gfs-baskerville-fonts
❄ gfs-bodoni-classic-fonts
❄ gfs-bodoni-fonts
❄ gfs-complutum-fonts
❄ gfs-didot-classic-fonts
❄ gfs-didot-fonts
❄ gfs-eustace-fonts
❄ gfs-fleischman-fonts
❄ gfs-garaldus-fonts
❄ gfs-gazis-fonts
❄ gfs-jackson-fonts
❄ gfs-neohellenic-fonts
❄ gfs-nicefore-fonts
❄ gfs-olga-fonts
❄ gfs-porson-fonts
❄ gfs-solomos-fonts
❄ gfs-theokritos-fonts
❄ nafees-web-naskh-fonts
❄ stix-fonts
❄ yanone-kaffeesatz-fonts

The new spec templates have been designed to be easy to update to from the previous guidelines, and to remove complexity from font packages. To help new package creation the fontpackages-devel package has been made available in Fedora 9 and 10.

If you have any remaining questions about the new guidelines please ask them
on:
fedora-fonts-list at redhat.com
Comment 3 Nicolas Mailhot 2009-01-04 05:06:51 EST
Hi Ankur,

This looks quite good and you've progressed a lot since your first submissions. However, you need to adapt this spec file to the new templates, like for your other submissions
Comment 4 Ankur Sinha 2009-01-04 11:29:44 EST
hi,

packages: 

http://ankursinha.fedorapeople.org/beteckna-0.3/beteckna-sfd-fonts-0.3-2.fc10.src.rpm

http://ankursinha.fedorapeople.org/beteckna-0.3/beteckna-sfd-fonts.spec

Gives this error while building packages..During the build using fontforge.."FindMatchinHVEdge didn't" I havent been able to understad what it is..Packages build normally though..

Getting this warning here too with rpmlint : "beteckna-sfd-fonts.noarch: W: symlink-should-be-relative /etc/fonts/conf.d/60-beteckna.conf /usr/share/fontconfig/conf.avail/60-beteckna.conf"

regards,
Comment 5 Nicolas Mailhot 2009-01-04 12:51:16 EST
Looks nice so here is a complete review:

1. probably better to use
%define	archivename	%{fontname}-%{version}

2. The summary needs a little work
(for example 'Geometric sans-serif font inspired by Futura')

3. you do not need to add "sfd" to the name, renaming is only a requirement for OFL fonts, GPL does not require it

4. beteckna.se seems dead, no need to reference it in the description

5. we already have a licensing field, do not include "The font is free, 
licensed under terms of the GNU GPL" in the description

6. You're wrapping your description lines too short, Fedora standard is 79 columns not 50

7. do package AUTHORS LICENSE CHANGELOG as %doc too

8. I see beteckna is actually 3 different font families: Beteckna, BetecknaLowerCase, Beteckna Small Caps. Please package them in 3 different subpackages using the -multi template (the two families which do not have a correct uppercase/lowercase mix are probably more "fantasy" than "sans-serif" fonts anyway)

9.[not a blocker] Please ask upstream to consider adding the FSF Font exception to their licensing so the font can be used by people who embed fonts in PDF files

10. Please change the category of the wiki page describing the font so other packagers see they need not work on it
http://fedoraproject.org/wiki/Beteckna_fonts
(see the help in http://fedoraproject.org/wiki/Font_description_template )

You do not need a packager sponsorship for this, just a Fedora FAS account

Anyway that's all mostly small stuff and nothing that should be too hard for you to fix.

⇒ NEEDINFO in the meanwhile
Comment 6 Nicolas Mailhot 2009-01-04 13:05:36 EST
PS for the fontforge warning, ask on the fontforge mailing list
Comment 7 Ankur Sinha 2009-01-13 03:59:41 EST
(In reply to comment #6)
> PS for the fontforge warning, ask on the fontforge mailing list

hi,

I've asked. No reply till date. No help on the IRC too. I'll try looking elsewhere. Any suggestions?

Also,I havent packaged a multi font yet so it will take me a while to understand the new spec. I'll refer the fonts already packaged and get it done as quickly as possible.

regards,

Ankur
Comment 8 Nicolas Mailhot 2009-01-13 04:11:47 EST
(In reply to comment #7)
> (In reply to comment #6)
> > PS for the fontforge warning, ask on the fontforge mailing list

> I've asked. No reply till date. No help on the IRC too. I'll try looking
> elsewhere. Any suggestions?

You can try to ask eimai or moyogo on #dejavu. Otherwise, not idea :(.

> Also,I havent packaged a multi font yet so it will take me a while to
> understand the new spec. I'll refer the fonts already packaged and get it done
> as quickly as possible.

Ok. There should be plenty of examples to take inspiration from in rawhide right now (dejavu, vera, mgopen, etc)
Comment 9 Ankur Sinha (FranciscoD) 2009-02-16 07:41:11 EST
Packages:
http://ankursinha.fedorapeople.org/beteckna-0.3/beteckna-sfd-fonts-0.3-3.fc10.src.rpm

http://ankursinha.fedorapeople.org/beteckna-0.3/beteckna-sfd-fonts.spec


It builds fine.. I am still having trouble with the %package etc part.. 
This package too, the rpm names arent as they are supposed to be..

Wrote: /home/Package/rpmbuild/SRPMS/beteckna-sfd-fonts-0.3-3.fc10.src.rpm
Wrote: /home/Package/rpmbuild/RPMS/noarch/beteckna-sfd-fonts-0.3-3.fc10.noarch.rpm
Wrote: /home/Package/rpmbuild/RPMS/noarch/beteckna-sfd-fonts-beteckna-sfd-general-fonts-0.3-3.fc10.noarch.rpm
Wrote: /home/Package/rpmbuild/RPMS/noarch/beteckna-sfd-fonts-beteckna-sfd-lower-case-fonts-0.3-3.fc10.noarch.rpm
Wrote: /home/Package/rpmbuild/RPMS/noarch/beteckna-sfd-fonts-beteckna-sfd-small-caps-fonts-0.3-3.fc10.noarch.rpm

Ive tried what the multi spec has in it.. Got stuck there.. Doing anything else with the spec gives me "%post file not found".. I've been stuck there for almost two weeks until i atleast managed to build this. One of you will have to please tell me how to do that part properly.. 

The fontforge warning/error persists. It gives a 0 exit status though.. Am waiting for a reply from the mailing list for confirmation.
Comment 10 Ankur Sinha (FranciscoD) 2009-02-16 11:49:50 EST
This is what George said about the error,"It indicates an internal problem in fontforge that will sometimes cause
an error. You can correct it by rewriting fontforge's code so that it
handles rounding errors better. This is not something I can do, but if
you can please do so.". I certainly cannot rewrite the code to fontforge. How should i handle it?
Comment 11 Nicolas Mailhot 2009-02-16 18:40:08 EST
1. your package names are broken because you're missing the -n switch to %package as documented in the template. Since your names are broken the auto-posts do not work

2. be careful to put the doc in the common subpackage not the main package

3. After koji's update next week-end you'll be able to drop all the
"Group:		User Interface/X" in subpackages, they'll be inherited from the main package declaration

4. You can ignore the fontforge warning since this is nothing you can do about short of changing the fontforge code, which is not your priority :p

Please update your package accordingly
Comment 12 Ankur Sinha (FranciscoD) 2009-03-07 03:06:33 EST
think i finally got it.. :D

packages:

http://ankursinha.fedorapeople.org/beteckna-0.3/beteckna-sfd-fonts-0.3-3.fc10.src.rpm

http://ankursinha.fedorapeople.org/beteckna-0.3/beteckna-sfd-fonts.spec

Do i need to mention anything anywhere about that edge error ?
Comment 13 Nicolas Mailhot 2009-03-16 16:11:17 EDT
I seem to have missed this update, sorry, should have looked at it way before. This package looks a lot more sane, but it still has the following mistakes

1. you're not buildrequiring fontforge, so it won't build. Please check your packages in mock or a koji scratch build before submitting

2. will probably need the same change as other packages to build on rawhide fontforge

3. I don't think you need to put sfd everywhere, unless the author requested it like for old standard

4. no idea if using %{common_desc} instead of %common_desc will have bad side-effects or not

5. you're not using the suggested fontconf form, it needs to be something like number-%{fontname} to work. To choose the right number see
/usr/share/fontconfig/templates/fontconfig-priorities.txt

6. It's considered bad form to mix $RPM_BUILD_ROOT and %{buildroot} in a single template

7. be careful to put your doc in the common subpackage, not the main package

8. you can put the "beteckna" font in the main package as it's named "beteckna" not "beteckna general". Look how the "gentium basic" package does it. The fontconfig file probably needs to be adapted
Comment 14 Ankur Sinha (FranciscoD) 2009-03-17 13:14:53 EDT
hi,

made the changes :

http://ankursinha.fedorapeople.org/beteckna-0.3/beteckna-fonts.spec

http://ankursinha.fedorapeople.org/beteckna-0.3/beteckna-fonts-0.3-4.fc10.src.rpm

tested the srpm using mock.. all processes returned 0 so im assuming it was a successful build..

regards,

Ankur
Comment 15 Ankur Sinha (FranciscoD) 2009-03-17 13:28:39 EDT
hi,

i got these in the output though..

DEBUG: Bad sfd file. Glyph igrave has width 207 even though it should be
DEBUG:   bound to the width of dotlessi which is 186.
DEBUG: Bad sfd file. Glyph iacute has width 207 even though it should be
DEBUG:   bound to the width of dotlessi which is 186.
DEBUG: Bad sfd file. Glyph icircumflex has width 207 even though it should be
DEBUG:   bound to the width of dotlessi which is 186.
DEBUG: Bad sfd file. Glyph idieresis has width 207 even though it should be
DEBUG:   bound to the width of dotlessi which is 186.
DEBUG: Bad sfd file. Glyph Agrave has width 695 even though it should be
DEBUG:   bound to the width of A which is 674.
DEBUG: Bad sfd file. Glyph Aring has width 695 even though it should be
DEBUG:   bound to the width of A which is 674.
DEBUG: Bad sfd file. Glyph Egrave has width 518 even though it should be
DEBUG:   bound to the width of E which is 483.
DEBUG: Bad sfd file. Glyph aring has width 476 even though it should be
DEBUG:   bound to the width of a which is 480.


How do i handle these?

Ankur
Comment 16 Nicolas Mailhot 2009-03-21 07:56:11 EDT
Hi Ankur

Some nitpicking:

1. your common_desc declaration is still using define not global

2. I'm not sure doing %clean after %files is a good idea

3. rpmlint complains of
beteckna-fonts.src: W: mixed-use-of-spaces-and-tabs (spaces: line 31, tab: line 1)

4. rpmlint complains of
beteckna-fonts-common.noarch: W: file-not-utf8 /usr/share/doc/beteckna-fonts-common-0.3/CHANGELOG

(see the gfs font specs for examples of txt file recoding to UTF-8)

5. it seems none of those fonts have normal minuscules. Therefore it'd probably be better to register them as "fantasy" not "sans-serif" in your fontconfig files

However the rest of the packaging is sane and much better than some of the stuff I've seen recently and the problems are not worth blocking import

⚶⚶⚶ APPROVED ⚶⚶⚶

Please do consider fixing the remaining small problems however


You can now continue from
https://fedoraproject.org/wiki/Font_package_lifecycle#3.a


As for the warnings emitted by fontforge during build, they unfortunately point problems in the original upstream file. You should relay them to the font author(s) so they get fixed.

If you're interested in learning some font creation stuff, you can try to fix them yourself, and create a patch for upstream. eimai and moyogo on #dejavu will usually be helpful to people discovering fontforge.

⇒ REASSIGNING now the review is done
Comment 17 Ankur Sinha (FranciscoD) 2009-03-21 10:25:29 EDT
New Package CVS Request
=======================
Package Name: beteckna-fonts
Short Description: Beteckna sans-serif fonts 
Owners: ankursinha
Branches: F-9 F-10
InitialCC: fonts-sig
Comment 18 Kevin Fenzi 2009-03-22 01:49:21 EDT
cvs done.
Comment 19 Fedora Update System 2009-03-24 07:02:05 EDT
beteckna-fonts-0.3-4.fc10 has been submitted as an update for Fedora 10.
http://admin.fedoraproject.org/updates/beteckna-fonts-0.3-4.fc10
Comment 20 Fedora Update System 2009-03-25 12:07:34 EDT
beteckna-fonts-0.3-4.fc10 has been pushed to the Fedora 10 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update beteckna-fonts'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F10/FEDORA-2009-3018
Comment 21 Fedora Update System 2009-04-17 14:04:21 EDT
beteckna-fonts-0.3-4.fc10 has been pushed to the Fedora 10 stable repository.  If problems still persist, please make note of it in this bug report.